#!/usr/bin/env python
import hashlib
import base64, random
import crypt
import string

alg = {
    'ssha':'Seeded SHA-1',
    'sha':'Secure Hash Algorithm',
    'smd5':'Seeded MD5',
    'md5':'MD5',
    'crypt':'Standard unix crypt'
    }

def getsalt(chars = string.ascii_letters + string.digits,length=16):
    salt = ""
    for i in range(int(length)):
        salt += random.choice(chars)
    return salt


def mkpasswd(pwd,hash='ssha'):
    if hash not in list(alg.keys()):
        return None
    else:
        salt = getsalt()
        if hash == "ssha":
            s = hashlib.sha1()
            s.update(str(pwd) + salt)
            return "{SSHA}" + base64.encodestring(s.digest() + salt)
        elif hash == "sha":
            s = hashlib.sha1()
            s.update(str(pwd))
            return "{SHA}" + base64.encodestring(s.digest())
        elif hash == "md5":
            s = hashlib.md5()
            s.update(str(pwd))
            return "{SHA}" + base64.encodestring(s.digest())
        elif hash == "smd5":
            s = hashlib.md5()
            s.update(str(pwd) + salt)
            return "{SMD%}" + base64.encodestring(s.digest() + salt)
        elif hash == "crypt":
            return "{CRYPT}" + crypt.crypt(str(pwd),getsalt(length=2))


if __name__ == "__main__":
    pwd = input("Password? ")
    for x in list(alg.keys()):
        print(pwd, "hashed in", x, "is", mkpasswd(pwd, x))
